# Configuration file for MOOS library.

# Pick up the auto-generated file which knows how to add the library targets
# This will mean that we don't have to supply full paths for the libraries
set(exports_file "${CMAKE_CURRENT_LIST_DIR}/UseMOOS.cmake")

if( NOT MOOS_FOUND)
    #only pull in if not already done!
    if (EXISTS ${exports_file})
        message(STATUS "CMake is running ${exports_file}")
        include(${exports_file})
    endif ()
endif()


include( FindPackageHandleStandardArgs )
find_package_handle_standard_args( MOOS DEFAULT_MSG exports_file )
message(STATUS "MOOS_FOUND=${MOOS_FOUND} time to dance")


# Project specific variables are dynamically inserted here

# Export variables for MOOS Library
set(MOOS_LIBRARIES "MOOS")
set(MOOS_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../include")
set(MOOS_DEPEND_LIBRARIES "pthread;m")
ADD_DEFINITIONS(-DASYNCHRONOUS_CLIENT)
message(STATUS "adding -DASYNCHRONOUS_CLIENT as required by MOOS")